'***********************************************************************************
' Amux_V35.bas   AudioKreuzschienen Steuerung                             7.11.2016*
''**********************************************************************************
' V35: identisch mit 34TT, nur Namensnderung
'----------------------------------------------------------------------------------
' V34_TT:  "luft" beim Herwig
'---------------------------------------------------------------------------------
' V34: Warum braucht man 2 EEProm-Bereiche ? (Vmux braucht nur einen)
'      Lsung: (Z ~337) Ch_ein(ekanal) = Ch_einx , oberer EEProm-Bereich entfllt!
'      Funktion "Alle Verbindungen trennen" wieder drin
' Vom Tomtom dazuprogrammiert:
'      Beim Einschalten "SET" gedrckt schaltet zwischen 8x8 und 16x16 um
'      Beim Einschalten "Taste Drehgeber" gedrckt schaltet Drehrichtung um
'----------------------------------------------------------------------------------
' V33: EEProm-Bereiche ausgetauscht AStandard ab 1, "Arbeitskonfig" +40
'-----------------------------------------------------------------------------------
' V32: Manuelle Einstellung wird nicht behalten/Gespeichert
'      Korrektur: AStandard in EEProm mit offset=40,
'                 "Arbeitskonfiguration" ab 1
'-----------------------------------------------------------------------------------
' V31: Standard aus EEProm, Standard-save in EEProm
'       0 1 * = Standard laden (aus EEProm)
'       0 0 * = Muster speichern (im EEProm)
'-----------------------------------------------------------------------------------
' V30: Audiostandard an jetzige Konfiguration angepat
'___________________________________________________________________________________
' V21: Standard gendert wg. ITV Dauerbetrieb
'      UND I2C Pins = 0 (keine pullups)
'-----------------------------------------------------------------------------------
' V20: Standard gendert wegen genderter Kanalzuordnung
'-----------------------------------------------------------------------------------
' V19: = V18 aber OHNE Standard 2 und ohne Save Standard
'-----------------------------------------------------------------------------------
' V18: = V16 + neue AMischer-Verschaltung
'-----------------------------------------------------------------------------------
' V16: Neuer Befehl: z.B. 5 0 * --> Eingang 5 von allen Ausgngen trennen
'      Bei Init/reset gleich Standard1 laden und in "unteren" EEProm-Bereich (der
'      immer der "Arbeitsspeicher" ist), Standard2 (0 * *) kommt in "oberen"
'      EEprom-Bereich und wird beim Auslesen auch sofort in den unteren kopiert
'-----------------------------------------------------------------------------------
' V15n: NUR neue AVMatrix-Verschaltung angepat ( Data)
'-----------------------------------------------------------------------------------
' V15: entweder Einzelkoppelpunkt oder alle zusammen abfragen (Btr = 32)
'      Wordbyte ersetzt durch High(WORD) und Low(WORD)
'      Bei Initialisierung (oder reset) gleich Standard1 laden // EEProm bleibt !
'-----------------------------------------------------------------------------------
' V14x: EEprom wird im Init-Teil NICHT gelscht; mu EINMAL per 01* oder 02* oder per
'       manueller Einstellung aktiviert werden.
'***********************************************************************************
' V14: Auswertung der empfangenen bytes in separater Sub
'***********************************************************************************
' V13: Neue Befehlsstruktur DTMF 0 (1-2) * (Bytewert 0 (1-2) 128)
'  Alle Ausgangskanle AUS: DTMF 0 0 * (0 0 128)
'  Aktuelle Konfiguration als Standard2 im EEprom speichern: DTMF 0 * * (0 128 128)
'                                       Aufruf mit: DTMF 0 2 * (0 2 128)
'  1 Standardkonfiguration und Abspeichern der aktuellen Konfiguration als 2

'  Eingabe gendert: Eingabe-, dann Ausgabekanal (NICHT -1)
'  Eingabe jetzt 3 bytes; 3. byte = Schalter (nur 0, 1, * und #)
'  Zeichen:  DTMF    PR        Byte zum slave
'            0-9     0-9       0-9
'            A-D     10-13     10-13
'            *       *         128
'            #       #         129
'**********************************************************************************
' - Kanalnummern 1 - 16
'**********************************************************************************
'* - Auslesen der Matrix Config per "Twi_master_needs_Byte":
'*   Bitwert (Ausgnge) werden per Overlay in Lo und Hi Byte zerlegt,
'*   Master-Abfrage einzeln und wieder zum WORD vereinigt (im Master)
'* - ARRAY (Ch_ein(i)) : enthlt Bitmuster der zugehrigen Ausgnge als WORD
'* ********************************************************************************
'*  2x16 LCD:  Zeile 1 = Eingabekanle  /  Zeile 2 = Ausgabekanle                *
'*  Bei Encoderbetrieb: Cursor in der Zeile deren Werte gendert werden           *
'*  bernahme neuer Ausgangskonfiguration durch Extra-Taste                       *
'**********************************************************************************
'* - Kanalwahl mit Encoder per Int0 ber flags (in/out=Encoder-Taste)             *
'*   UND
'*   per I2C-Bus mit 3 bytes: 1. Byte = Eingangskanal, 2. Byte = Ausgangskanal
'*                            3. Byte Ausgangskanal EIN (1) oder AUS (0)
'*   Nach I2C-Eingabe wird Display neu geschrieben
'    UND Matrix neu geladen
'    UND Eeprom "upgedated"
'                                                                         *
'**********************************************************************************
'*Allgemeine Definitionen
'**********************************************************************************
$regfile = "M8def.dat"
'$regfile = "M168def.dat"
$crystal = 8000000                                          ' interner RC-Oszillator
'$baud = 115200                                    ' nur zum debuggen

Debug Off
'Osccal = &HBF                                     ' fr "exakte" 8MHz wg. UART
'Ucsrb = 0                                                   ' UART Pins abschalten

$framesize = 32                                             ' Frames
$swstack = 32                                               ' Software stack
$hwstack = 32                                               ' Hardware stack

'**************************************************************************
'* LCD-Einstellungen
'**************************************************************************
Config Lcdpin = Pin , Rs = Portb.0 , E = Portb.1 , Db4 = Portb.2 , Db5 = Portb.3 , _
 Db6 = Portb.4 , Db7 = Portb.5
Config Lcdbus = 4
Config Lcd = 16 * 2
'**************************************************************************
'* TWI Slave config
'**************************************************************************
Config Twislave = &H64 , Btr = 32 , Bitrate = 100000        ' Adresse = 100 / max 32 bytes / 100kHz
$lib "i2c_twi.lbx"                                          ' ist Teil der "i2cslave.lib"
Config Scl = Portc.5                                        '
Config Sda = Portc.4
Portc.4 = 0
Portc.5 = 0

'*************************************************************************
'* Port config:
'*************************************************************************
Config Portc = &B0000_1111                                  ' 0 - 3 output
Clk Alias Portc.0                                           ' 4094 Pin 3
Dat Alias Portc.1                                           ' 4094 Pin 2
Strb Alias Portc.2                                          ' 4094 Pin 1

Config Portd = &B0000_0000                                  ' Input fr manuelle Steuerung
Auf Alias Pind.0                                            ' fr Taster
Ab Alias Pind.1                                             '
' Pind.2 (INT0) an Encoder A***********
Dschalter Alias Pind.3                                      ' Druckschalter am Encoder
Updown Alias Pind.4                                         ' Encoder Pin B
Neu Alias Pind.5                                            ' per Taster eingestellte Daten bernehmen
Portd = &B0011_1111                                         ' pullup fr 0 bis 5

Config Int0 = Change                                        ' an Pind.2 auf Flanke warten

'*************************************************************************
'* Variable
'*************************************************************************

Dim N As Byte , I As Byte , K As Byte
Dim Ekanal As Byte                                          ' Index fr Eingangskanal
Dim Ch_ein(16) As Word                                      ' Ausgangswerte zu CH_ein(n)
'Dim Offset As Byte                                ' fr "oberen" EEProm-Bereich (Standard2)

Dim Ch_einx As Word
Dim Ch_bit(16) As Byte                                      ' einzelne Ausgnge

Dim Zeile As Byte
Dim Pos As Byte
Dim Pos_old As Byte                                         ' Cursorposition (Zeile/Position) und Merker

Dim Eepos As Byte                                           ' Speicherplatz (im EEProm)
'--------------------------
Dim Outdat As Word                                          ' fr shiftout zum Mux
'---------------------------
Dim Plus As Bit                                             ' als Interrupt flags
Dim Minus As Bit
Dim Neue_daten As Bit                                       ' flag fr Datenempfang vom Master
'----------------------------
Dim K_aus As Word                                           '
Dim W_aus As Word
Dim Masterbyte As Byte
Dim Byte_count As Byte
Dim Shift_count As Word                                     '
Dim Read_count As Byte                                      ' Zhler beim Auslesen
Dim Schalter As Byte                                        '

Dim Kanal_status As Word                                    ' eingeschaltet oder ausgeschaltet

Dim V As Byte                                               ' Zhlvariable bei Byteanforderung durch Master
Dim Dummy As Word
Dim Temp As Byte                                            '
Dim Xmalx As Byte                                           ' Umschaltung fr 8x8 oder 16x16 zur Laufzeit
Dim Drehrichtung As Byte                                    ' Umschaltung der Drehrichtung zur Laufzeit

Declare Sub Dectobin(ch_einx As Word)
Declare Sub Bintodec(ch_bit(n) As Byte)

'****************************************************************************************
'* Initialisierung
'****************************************************************************************
'$sim                                              ' DEBUG only

Byte_count = 0                                              ' fr Masterbyte
Cls
Waitms 25
Cursor Off

'Umschaltung 8x8 oder 16x16
Readeeprom Xmalx , 0
If Neu = 0 Then
   Select Case Xmalx
      Case 8
         Xmalx = 16
      Case 16
         Xmalx = 8
      Case Else
         Xmalx = 16
   End Select
   Writeeeprom Xmalx , 0
   LCD  Xmalx
   LCD  " mal "
   LCD  Xmalx
   wait 3
   Cls
End If
'Umschaltung Drehrichtung
Readeeprom Drehrichtung , 1
If Dschalter = 0 Then
   Toggle Drehrichtung.0
   Writeeeprom Drehrichtung , 1
   lcd "Drehrichtungswechsel"
   wait 3
End If

Lcd "AMIX_V35"                                              ' I'm alive !
Lowerline
Lcd Xmalx
Lcd "x"
Lcd Xmalx
Debug "AMIX_V35"
Wait 3
Debug "Nu geit dat lous!"
Cursor On Blink
Upperline
Lcd "1234567890123456"                                      ' Erste Zeile zeigt Ch_ein(n)
Zeile = 1
Pos = 1

K_aus = 1                                                   ' beim Start/reset gleich Standard laden
Gosub Astandard_laden                                       ' NEU aus EEProm

Enable Int0                                                 ' Interrupts erst jetzt zulassen
Enable Interrupts

'****************************************************************
'******************* Hauptprogramm ******************************
'****************************************************************
On Int0 Isr0

Do
   Debounce Dschalter , 0 , Einaus , Sub                    ' Toggle Zeile
   Debounce Neu , 0 , Neu_manuell , Sub                     ' setzen/lschen eines neuen Ausgangskanals
   Locate Zeile , Pos
   If Plus = 1 Then Gosub Plusplus                          ' Auswertung der Interrupt flags
   If Minus = 1 Then Gosub Minusminus
   If Neue_daten = 1 Then Gosub Daten_auswertung            ' Auswertung der 3 neuen bytes
   'Gosub Twi_gotdata                              ' DEBUG only    DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD
Loop

End
'****************************************************************
'********************** Subs ************************************
'****************************************************************

'-------------- 3 neue Bytes vom Master empfangen ---------------------------
Daten_auswertung:
   Neue_daten = 0

   If Schalter = 1 Or Schalter = 0 Then
      Gosub Neu_i2c
   End If

   If Schalter = 128 Then
      If Ekanal > 0 And K_aus = 0 Then
         Gosub Kanal_lschen
      End If
      If Ekanal = 0 Then
         Select Case K_aus
            Case 0
               Gosub Astandard_speichern                    '
            Case 1
               Gosub Astandard_laden
            Case 2
               Gosub Alles_aus
         End Select
      End If
   End If

Return

'---------------------------------------------------------------
Astandard_laden:                                            ' NEU aus EEProm

      For N = 2 To 32 Step 2                                ' Var (WORD) aus EEProm lesen
      I = N / 2
      Readeeprom Ch_ein(i) , N                              ' 2er Schritte wg. Word-Format
   Next N

   Ekanal = 1                                               ' mit Eingang 1 beginnen
   Gosub Lcd0                                               ' Display mit Standardkonfiguration
   Locate Zeile , Pos
   Gosub 256bitausgabe                                      ' jetzt Matrix "laden"

Return

'-------------------------------------------------------------------------------------------
Astandard_speichern:                                        ' in EEProm

   For N = 2 To 32 Step 2                                   ' Var (WORD) in EEProm schreiben
      I = N / 2
      Writeeeprom Ch_ein(i) , N                             ' 2er Schritte wg. Word-Format
   Next N

Return

'-------------------------------------------------------------
Kanal_lschen:                                              '
   Ch_ein(ekanal) = 0
   Ekanal = 1
   Gosub Lcd0
   Locate Zeile , Pos
   Gosub 256bitausgabe
Return

'--------------------------------------------------------------------------------------
Alles_aus:                                                  ' ... alle Ausgnge ohne Signal
   Dummy = 0

   For N = 1 To Xmalx                                       ' alle Werte auf 0
      I = N
      Ch_ein(i) = Dummy
   Next N

   Ekanal = 1                                               ' mit Eingang 1 beginnen
   Gosub Lcd0                                               ' Display Konfiguration
   Locate Zeile , Pos
   Gosub 256bitausgabe                                      ' jetzt Matrix "laden" = alles AUS
Return

'-------------------------------------------------------------------
Plusplus:
Debug ">Plusplus"
   If Zeile = 1 Then                                        ' Cursor in der 1. Zeile
      Pos = Pos + 1
      If Pos > Xmalx Then Pos = 1
      Ekanal = Pos                                          'Ekanal + 1             ' nchstes ch_ein
      Gosub Lcd0                                            ' ... und ch_bit(n) auf den Display
   Else
      Pos = Pos + 1                                         ' Cursor P eins weiter
      If Pos > Xmalx Then Pos = 1                           ' berlauf
      Locate Zeile , Pos                                    ' Cursor neue Position
   End If
   Plus = 0                                                 ' Flag wieder zurcksetzen
Return

'-----------------------------------------------------------------
Minusminus:
Debug ">Minusminus"
   If Zeile = 1 Then
      Pos = Pos - 1
      If Pos < 1 Then Pos = Xmalx
      Ekanal = Pos
      Gosub Lcd0
   Else
      Pos = Pos - 1
      If Pos < 1 Then Pos = Xmalx
      Locate Zeile , Pos
   End If
   Minus = 0                                                ' Flag zurcksetzen
Return

'------------------------------------------------------------------
Einaus:                                                     '
Debug ">Einaus"
   If Zeile = 1 Then                                        ' Zeilenwechsel
      Zeile = 2
      Pos_old = Pos
   Else
      Zeile = 1
      Pos = Pos_old
   End If
   Locate Zeile , Pos
Return

'-------------------------------------------------------------------------
Neu_manuell:                                                ' Ausgangskanal manuell neu belegen
Debug ">Neu_manuell"
   If Zeile = 1 Then Goto Raus1                             ' cursor beim Eingangskanal, nix tun!
   If Ch_bit(pos) < 1 Then                                  ' Kanal "leer",
      Ch_bit(pos) = 1                                       'Pos           ' ...dann setzen
   Else
      Ch_bit(pos) = 0                                       ' sonst "leeren"
   End If
   Gosub Lcd1                                               ' Ch_bit

Debug "Zeile:" ; Zeile
Debug "Pos:" ; Pos

   Call Bintodec(ch_bit(n))
Debug "Ch_einx:" ; Ch_einx
   Ch_ein(ekanal) = Ch_einx                                 ' ... das ist es NNNNNNNNNNNNNNNNNNNNN
Debug "Ch_ein(ekanal):" ; Ch_ein(ekanal)
   Gosub 256bitausgabe
Raus1:
Return

'--------------------------------------------------------------------
Neu_i2c:                                                    ' via I2C
   Shift_count = K_aus - 1
   W_aus = 2 ^ Shift_count
   Kanal_status = Ch_ein(ekanal) And W_aus                  '

   If Schalter = 1 Then
      If Kanal_status = 0 Then                              ' wenn Ausgangskanal nicht schon gesetzt, dann
         Ch_ein(ekanal) = Ch_ein(ekanal) + W_aus            ' Schalter = EIN : Ausgangskanal ffnen/addieren
      End If
   Elseif Schalter <> 1 Then                                '
      If Kanal_status = W_aus Then                          ' wenn Ausgangskanal gesetzt, dann
         Ch_ein(ekanal) = Ch_ein(ekanal) - W_aus            ' Schalter = AUS : Ausgangskanal schlieen/subtrahieren
      End If
   End If

   Gosub Lcd0                                               ' ...und anzeigen
   Pos = Ekanal

   Gosub 256bitausgabe

Return

'---------------------------------------------------------------------
Lcd0:
   Ch_einx = Ch_ein(ekanal)
   Call Dectobin(ch_einx)
Lcd1:
   Locate 2 , 1
   For N = 1 To Xmalx
      I = N - 1
      If Ch_bit(n) = 1 Then
         Lcd "*"                                            '
      Else
         Lcd "."                                            '
      End If
   Next N
Return

'***************************************************************
'* Daten ---> Matrix     (16 x 16 bit)
'***************************************************************
256bitausgabe:
  Dim Zz As Byte
   Strb = 0

   For N = 16 To 1 Step -1                                  ' "hinterste" zuerst
     Outdat = Ch_ein(n)                                     ' NNNNNNNNNNNNNNNNNNNNN die hat gefehlt
     Zz = Xmalx
      If Zz = 8 Then
         Zz = Low(outdat)
         Shiftout Dat , Clk , Zz , 1                        ' 1 = MSB first when clock high
      Else
         Shiftout Dat , Clk , Outdat , 1                    ' 1 = MSB first when clock high
      End If
   Next N

   Strb = 1
   Waitus 10                                                'Delay             ' ca. 10 us
   Strb = 0
Return

'-------------------------------------
Sub Dectobin(ch_einx As Word)
   For N = 1 To 16
      Ch_bit(n) = Ch_einx And 1
      Shift Ch_einx , Right , 1
   Next N
End Sub

'-------------------------------------
Sub Bintodec(ch_bit(n) As Byte)
   Dim Bitwert As Word
   Ch_einx = 0
   For N = 1 To 16
      I = N - 1
      Bitwert = 2 ^ I
      If Ch_bit(n) = 1 Then
         Ch_einx = Ch_einx + Bitwert
      End If
   Next N
End Sub


'*************************************************************************
'* Interrupt Services
'*************************************************************************
Isr0:                                                       ' Encoder Auswertung
   If Pind.2 = Updown Then
      If Drehrichtung.0 = 0 Then
         Plus = 1
      Else
         Minus = 1                                          ' Flag setzen
      End If                                                ' Flag setzen
   Else
      If Drehrichtung.0 = 0 Then
         Minus = 1
      Else
         Plus = 1
      End If                                                ' Flag setzen
   End If
Return

'------- Daten vom Master (Eingangskanal / Ausgangskanal / Schalter)---
Twi_gotdata:                                                ' neue Daten vom Master

   Masterbyte = Twi                                         ' neue Daten merken

   If Masterbyte > 64 And Masterbyte < 128 Then             ' wegen * und # (128 und 129) beim DTMF
      V = Masterbyte - 64
      Read_count = 0                                        ' Auslesen startet
   Else
      If Byte_count = 0 Then
         Ekanal = Masterbyte                                '
         Byte_count = 1
      Elseif Byte_count = 1 Then
         K_aus = Masterbyte                                 ' Ausgangskanal
         Byte_count = 2
      Elseif Byte_count = 2 Then
         Schalter = Masterbyte                              ' 1, 0, * oder #
         Byte_count = 0                                     ' wieder von vorne
         Neue_daten = 1                                     ' 3 neue bytes vom Master
      End If
   End If
Return

'------------------------------------
Twi_master_needs_byte:                                      ' Reihenfolge Hi -- Lo

   If Read_count = 0 Then
      Twi = High(ch_ein(v))
      Read_count = 1
   Else
      Twi = Low(ch_ein(v))
      Read_count = 0
      V = V + 1
   End If

Return

'--------------------- mssen im Quelltext sein (nicht benutzt) ---------------
Twi_stop_rstart_received:
   nop
Return
Twi_addressed_goread:
   nop
Return
Twi_addressed_gowrite:
   nop
Return
Twi_master_need_nomore_byte:
   nop
Return

'*************************************************************************
'* Defaultwerte zur Initialisierung der Eingabekanle
'*************************************************************************
$eeprom
Data 8,1 , 1% , 2% , 4% , 8% , 16% , 32% , 64% , 128%        ' dummy, 1-8
Data 256% , 512% , 1024% , 2048% , 4096% , 8192% , 16384% , 32768%       ' 9-16
$data

'-------------------------------------------------------------------------------